//header for Routing_Table.cpp

#ifndef deftestip
 #include "IP.h"
#endif

#define detestrt

//path types
#define INTRA_AREA 1


typedef struct
{
  char path_Type;//always set to "INTRA_AREA"
  unsigned short cost;
  IP next_Hop;
}
path;

typedef struct
{
  char destination_Type;
  IP destination_ID;
  IP address_Mask;
  int pathCount;
  path* paths;
}
rtEntry;

class Routing_Table 
{

 public:
	Routing_Table();
	~Routing_Table();
	int addRoute(char dT, IP dID, IP aM);
	int addRoute(char dT, IP dID);
	int addPath(IP dID, unsigned short cost, IP next);
	char getDType(IP dID);
	IP getDID(int index);
	IP getAM(IP dID);
	int getPathCount(IP dID);
	unsigned short getCost(IP dID, int index);
	IP getNH(IP dID, int index);
	char getPathType(IP dID, int index);
	int getSize();
	int initialize();

  // Data Members for Class Attributes
 private:
	 int size;
	 rtEntry* entries;
};

